using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using GxPress.Common.Page;
using GxPress.Request.App.Group;
using GxPress.Request.App.GroupUser;
using GxPress.Result.App.Group;
using GxPress.Result.App.GroupUser;

namespace GxPress.Service.Interface.Group
{
    public interface IGroupService : IService
    {
        Task<GroupDetailResult> InsertGroup(GroupInRequest request);
        Task<PagedList<GroupUserFindResult>> FindGroupByGroupFolderIdAsync(GroupSearchRequest request);

        Task<bool> InsertsAsync(GroupUserInRequest request);

        /// <summary>
        /// 小组添加用户
        /// </summary>
        /// <param name="request"></param>
        /// <returns></returns>
        Task<bool> AddUsersAsync(GroupUserInRequest request);
        /// <summary>
        /// 移除小组成员
        /// </summary>
        /// <param name="request"></param>
        /// <returns></returns>
        Task<bool> DeleteAsync(GroupUserDeRequest request);

        /// <summary>
        /// 退出小组
        /// </summary>
        /// <param name="userId"></param>
        /// <param name="groupId"></param>
        /// <returns></returns>
        Task<bool> DeleteAsync(int userId, int groupId);

         Task<GroupDetailResult> GroupDetailAsync(GroupDetailRequest request);

         /// <summary>
         /// 获取小组详情
         /// </summary>
         /// <param name="guId"></param>
         /// <param name="userId"></param>
         /// <returns></returns>
         Task<GroupDetailResult> GroupDetailByGuIdAsync(string guId,int userId);
    }
}
